; Geoff is the only teacher of Joe (hint - functions have only one
; result). Joe is not stupid but Joe failed. If a student failed then
; either the student is stupid or there is is some other student with
; the same teacher who also failed. Therefore there is some student other
; than Joe, also taught by Geoff, who also failed.

(set-option :produce-proofs true)
(set-option :proof-format-mode alethe)
(set-option :proof-granularity dsl-rewrite)
(set-logic UF)

(declare-sort Teacher 0)
(declare-sort Student 0)
(declare-fun teacherOf (Student) Teacher)
(declare-fun isStupid (Student) Bool)
(declare-fun failed (Student) Bool)
(declare-const geoff Teacher)
(declare-const joe Student)

(assert (= (teacherOf joe) geoff))
(assert (not (isStupid joe)))
(assert (failed joe))
(assert (forall ((x Student)) (or (isStupid x)
                                  (exists ((y Student)) (and (not (= x y))
                                                             (= (teacherOf x) (teacherOf y))
                                                             (failed y))))))
(assert (not (exists ((x Student)) (and (not (= x joe))
                                        (failed x)
                                        (= (teacherOf x) geoff)))))

(check-sat)
(get-proof)
