/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         yy2parse
#define yylex           yy2lex
#define yyerror         yy2error
#define yydebug         yy2debug
#define yynerrs         yy2nerrs
#define yylval          yy2lval
#define yychar          yy2char

/* First part of user prologue.  */
#line 8 "src/parsers/smtlib2/smtsyn.y"


#include <stdbool.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "utils/general.h"
#include "response.h"

#include "parsers/smtlib2/smttypes.h"
#include "parsers/smtlib2/smtfun.h"
#include "parsers/smtlib2/smtlib2.h"

#define yylineno yy2lineno
#define yyin yy2in
#define yylex_destroy yy2lex_destroy

#define YYMAXDEPTH 1500000

/* Define DEBUG_PARSER to see lots of info about compiler */

extern int flex(void);
extern int yylineno;

void yyerror(char *s);

void
yyerror(char *s)
{
  if (!strcmp(s,"memory exhausted"))
    printf("The following error may happen on parsing very large"
           " benchmarks.  "
           "If you really want to make the parser read your formula, "
           "you can set \"#define YYMAXDEPTH %d\" in smtsyn.y"
           "to a greater value\n", YYMAXDEPTH);
  my_error("%s on line %d\n", s, yylineno);
}
 /* TODO: there is a cast from Tsort to variables: sort_variable_lookup */


#line 120 "src/parsers/smtlib2/smtsyn.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "smtsyn.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_NUMERAL = 3,                    /* NUMERAL  */
  YYSYMBOL_DECIMAL = 4,                    /* DECIMAL  */
  YYSYMBOL_HEXADECIMAL = 5,                /* HEXADECIMAL  */
  YYSYMBOL_BINARY = 6,                     /* BINARY  */
  YYSYMBOL_STRING = 7,                     /* STRING  */
  YYSYMBOL_SYMBOL = 8,                     /* SYMBOL  */
  YYSYMBOL_KEYWORD = 9,                    /* KEYWORD  */
  YYSYMBOL_TK_EOF = 10,                    /* TK_EOF  */
  YYSYMBOL_TK_BANG = 11,                   /* "!"  */
  YYSYMBOL_TK_UNDERSCORE = 12,             /* "_"  */
  YYSYMBOL_TK_AS = 13,                     /* "as"  */
  YYSYMBOL_TK_ASSERT = 14,                 /* "assert"  */
  YYSYMBOL_TK_BACKGROUND = 15,             /* "background"  */
  YYSYMBOL_TK_BOOL = 16,                   /* "Bool"  */
  YYSYMBOL_TK_CHECK_SAT = 17,              /* "check-sat"  */
  YYSYMBOL_TK_CONTINUED_EXECUTION = 18,    /* "continued-execution"  */
  YYSYMBOL_TK_DECLARE_FUN = 19,            /* "declare-fun"  */
  YYSYMBOL_TK_DECLARE_CONST = 20,          /* "declare-const"  */
  YYSYMBOL_TK_DECLARE_SORT = 21,           /* "declare-sort"  */
  YYSYMBOL_TK_DEFINE_FUN = 22,             /* "define-fun"  */
  YYSYMBOL_TK_DEFINE_SORT = 23,            /* "define-sort"  */
  YYSYMBOL_TK_DISTINCT = 24,               /* "distinct"  */
  YYSYMBOL_TK_ECHO = 25,                   /* "echo"  */
  YYSYMBOL_TK_ERROR = 26,                  /* "error"  */
  YYSYMBOL_TK_EXISTS = 27,                 /* "exists"  */
  YYSYMBOL_TK_EXIT = 28,                   /* "exit"  */
  YYSYMBOL_TK_FALSE = 29,                  /* "false"  */
  YYSYMBOL_TK_FORALL = 30,                 /* "forall"  */
  YYSYMBOL_TK_GET_ASSERTIONS = 31,         /* "get-assertions"  */
  YYSYMBOL_TK_GET_ASSIGNMENT = 32,         /* "get-assignment"  */
  YYSYMBOL_TK_GET_INFO = 33,               /* "get-info"  */
  YYSYMBOL_TK_GET_OPTION = 34,             /* "get-option"  */
  YYSYMBOL_TK_GET_PROOF = 35,              /* "get-proof"  */
  YYSYMBOL_TK_GET_UNSAT_CORE = 36,         /* "get-unsat-core"  */
  YYSYMBOL_TK_GET_MODEL = 37,              /* "get-model"  */
  YYSYMBOL_TK_GET_VALUE = 38,              /* "get-value"  */
  YYSYMBOL_TK_IMMEDIATE_EXIT = 39,         /* "immediate-exit"  */
  YYSYMBOL_TK_INCOMPLETE = 40,             /* "incomplete"  */
  YYSYMBOL_TK_LET = 41,                    /* "let"  */
  YYSYMBOL_TK_LOGIC = 42,                  /* "logic"  */
  YYSYMBOL_TK_NONE = 43,                   /* "none"  */
  YYSYMBOL_TK_NUMERAL = 44,                /* "NUMERAL"  */
  YYSYMBOL_TK_MEMOUT = 45,                 /* "memout"  */
  YYSYMBOL_TK_PAR = 46,                    /* "par"  */
  YYSYMBOL_TK_POP = 47,                    /* "pop"  */
  YYSYMBOL_TK_PUSH = 48,                   /* "push"  */
  YYSYMBOL_TK_DECIMAL = 49,                /* "DECIMAL"  */
  YYSYMBOL_TK_SET_INFO = 50,               /* "set-info"  */
  YYSYMBOL_TK_SET_LOGIC = 51,              /* "set-logic"  */
  YYSYMBOL_TK_SET_OPTION = 52,             /* "set-option"  */
  YYSYMBOL_TK_STRING = 53,                 /* "STRING"  */
  YYSYMBOL_TK_THEORY = 54,                 /* "theory"  */
  YYSYMBOL_TK_TRUE = 55,                   /* "true"  */
  YYSYMBOL_TK_UNSUPPORTED = 56,            /* "unsupported"  */
  YYSYMBOL_TK_PATTERN = 57,                /* ":pattern"  */
  YYSYMBOL_TK_NAMED = 58,                  /* ":named"  */
  YYSYMBOL_TK_LAMBDA = 59,                 /* "@lambda"  */
  YYSYMBOL_60_ = 60,                       /* '('  */
  YYSYMBOL_61_ = 61,                       /* ')'  */
  YYSYMBOL_62___ = 62,                     /* '_'  */
  YYSYMBOL_YYACCEPT = 63,                  /* $accept  */
  YYSYMBOL_file = 64,                      /* file  */
  YYSYMBOL_script = 65,                    /* script  */
  YYSYMBOL_command = 66,                   /* command  */
  YYSYMBOL_67_1 = 67,                      /* $@1  */
  YYSYMBOL_68_2 = 68,                      /* $@2  */
  YYSYMBOL_69_3 = 69,                      /* $@3  */
  YYSYMBOL_exit_command = 70,              /* exit_command  */
  YYSYMBOL_option = 71,                    /* option  */
  YYSYMBOL_info = 72,                      /* info  */
  YYSYMBOL_symbol_list_empty = 73,         /* symbol_list_empty  */
  YYSYMBOL_term = 74,                      /* term  */
  YYSYMBOL_75_4 = 75,                      /* $@4  */
  YYSYMBOL_76_5 = 76,                      /* $@5  */
  YYSYMBOL_77_6 = 77,                      /* $@6  */
  YYSYMBOL_lambda = 78,                    /* lambda  */
  YYSYMBOL_79_7 = 79,                      /* $@7  */
  YYSYMBOL_term_attr = 80,                 /* term_attr  */
  YYSYMBOL_term_list = 81,                 /* term_list  */
  YYSYMBOL_bind = 82,                      /* bind  */
  YYSYMBOL_bind_list = 83,                 /* bind_list  */
  YYSYMBOL_var = 84,                       /* var  */
  YYSYMBOL_stack_var = 85,                 /* stack_var  */
  YYSYMBOL_sort_var = 86,                  /* sort_var  */
  YYSYMBOL_sort_var_list = 87,             /* sort_var_list  */
  YYSYMBOL_stack_var_empty = 88,           /* stack_var_empty  */
  YYSYMBOL_sort = 89,                      /* sort  */
  YYSYMBOL_sort_list = 90,                 /* sort_list  */
  YYSYMBOL_sort_list_empty = 91,           /* sort_list_empty  */
  YYSYMBOL_numeral_list = 92,              /* numeral_list  */
  YYSYMBOL_attr_value = 93,                /* attr_value  */
  YYSYMBOL_s_expr = 94,                    /* s_expr  */
  YYSYMBOL_s_expr_list = 95,               /* s_expr_list  */
  YYSYMBOL_spec_const = 96,                /* spec_const  */
  YYSYMBOL_b_value = 97                    /* b_value  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  28
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   459

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  63
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  35
/* YYNRULES -- Number of rules.  */
#define YYNRULES  113
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  279

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   314


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      60,    61,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,    62,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   161,   161,   162,   163,   164,   167,   168,   171,   172,
     173,   174,   176,   178,   181,   184,   187,   186,   191,   195,
     197,   194,   203,   204,   205,   206,   207,   208,   211,   213,
     215,   216,   217,   218,   219,   222,   236,   237,   238,   239,
     240,   259,   260,   261,   262,   265,   266,   277,   278,   279,
     280,   281,   283,   284,   286,   287,   289,   291,   293,   295,
     295,   298,   298,   301,   301,   304,   307,   311,   311,   314,
     317,   318,   319,   321,   323,   327,   328,   331,   334,   335,
     338,   341,   342,   346,   349,   350,   353,   354,   357,   358,
     359,   362,   374,   375,   378,   379,   382,   383,   395,   396,
     397,   400,   401,   402,   403,   406,   407,   410,   411,   412,
     413,   414,   417,   418
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "NUMERAL", "DECIMAL",
  "HEXADECIMAL", "BINARY", "STRING", "SYMBOL", "KEYWORD", "TK_EOF",
  "\"!\"", "\"_\"", "\"as\"", "\"assert\"", "\"background\"", "\"Bool\"",
  "\"check-sat\"", "\"continued-execution\"", "\"declare-fun\"",
  "\"declare-const\"", "\"declare-sort\"", "\"define-fun\"",
  "\"define-sort\"", "\"distinct\"", "\"echo\"", "\"error\"", "\"exists\"",
  "\"exit\"", "\"false\"", "\"forall\"", "\"get-assertions\"",
  "\"get-assignment\"", "\"get-info\"", "\"get-option\"", "\"get-proof\"",
  "\"get-unsat-core\"", "\"get-model\"", "\"get-value\"",
  "\"immediate-exit\"", "\"incomplete\"", "\"let\"", "\"logic\"",
  "\"none\"", "\"NUMERAL\"", "\"memout\"", "\"par\"", "\"pop\"",
  "\"push\"", "\"DECIMAL\"", "\"set-info\"", "\"set-logic\"",
  "\"set-option\"", "\"STRING\"", "\"theory\"", "\"true\"",
  "\"unsupported\"", "\":pattern\"", "\":named\"", "\"@lambda\"", "'('",
  "')'", "'_'", "$accept", "file", "script", "command", "$@1", "$@2",
  "$@3", "exit_command", "option", "info", "symbol_list_empty", "term",
  "$@4", "$@5", "$@6", "lambda", "$@7", "term_attr", "term_list", "bind",
  "bind_list", "var", "stack_var", "sort_var", "sort_var_list",
  "stack_var_empty", "sort", "sort_list", "sort_list_empty",
  "numeral_list", "attr_value", "s_expr", "s_expr_list", "spec_const",
  "b_value", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-160)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -44,   407,    20,   -44,  -160,  -160,    50,   -37,    26,    24,
      29,    38,    34,    63,    17,    35,    51,   114,   125,    76,
      98,   102,   104,   162,   165,   160,   169,   161,  -160,  -160,
    -160,  -160,  -160,  -160,  -160,  -160,  -160,  -160,  -160,   353,
     118,  -160,   167,  -160,  -160,   115,   134,    15,   178,   308,
     136,   131,   132,  -160,  -160,  -160,   133,   137,  -160,  -160,
    -160,    50,   138,   139,   342,   140,   143,   315,   155,    50,
      50,    54,    50,   159,   172,   173,   174,   199,   212,    50,
    -160,   348,   175,   213,  -160,    15,   179,  -160,  -160,     1,
     166,   168,   363,   180,   204,  -160,  -160,  -160,  -160,  -160,
      22,  -160,  -160,  -160,  -160,  -160,  -160,  -160,  -160,  -160,
    -160,  -160,  -160,  -160,  -160,    96,  -160,    15,   203,   112,
     206,   206,   208,   206,    72,   -19,   214,   237,   123,  -160,
    -160,  -160,  -160,    50,  -160,  -160,    15,   231,   261,   285,
      15,  -160,  -160,    25,  -160,   206,   233,  -160,   261,    13,
     234,  -160,   247,   268,  -160,   236,   290,  -160,   291,    46,
      82,   292,  -160,    93,   101,    15,   242,   237,  -160,     7,
    -160,   275,   142,  -160,    15,  -160,  -160,    27,   237,    31,
      15,  -160,  -160,    36,  -160,    15,  -160,  -160,  -160,  -160,
    -160,  -160,  -160,  -160,  -160,   237,  -160,  -160,    50,  -160,
    -160,  -160,   244,   295,     8,  -160,  -160,  -160,  -160,   245,
     249,  -160,    10,  -160,   256,    15,  -160,   263,   282,    11,
      50,    50,   264,    50,    50,    50,   237,    50,  -160,   302,
    -160,  -160,    50,   266,  -160,  -160,    15,   269,   270,  -160,
     271,   272,   182,    12,   202,   267,   273,   330,   278,  -160,
    -160,  -160,  -160,  -160,    15,  -160,    15,  -160,   280,  -160,
     296,   297,   206,    50,    15,   298,   241,   299,  -160,  -160,
     301,    15,   304,    50,  -160,   306,   311,   312,  -160
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       2,     0,     0,     4,     6,     3,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     1,     7,
       5,   107,   108,   109,   110,   111,    50,    49,    48,     0,
       0,    66,     0,    47,    25,     0,     0,     0,     0,     0,
       0,     0,     0,    35,    26,    30,     0,     0,    27,    28,
      33,     0,     0,     0,    41,     0,     0,    36,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      24,    71,     0,     0,    65,    94,     0,    89,    88,     0,
       0,     0,    86,     0,     0,    45,    34,    31,    32,    75,
       0,    23,    22,    43,   105,    42,     9,     8,    38,   113,
     112,   105,    37,    39,    10,     0,    70,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    99,
     105,    72,    98,     0,    73,    92,    95,     0,     0,     0,
       0,    15,    11,     0,    81,    87,     0,    18,     0,     0,
       0,    76,     0,     0,    54,     0,     0,    58,     0,     0,
       0,     0,    78,     0,     0,     0,     0,     0,    96,     0,
      69,     0,     0,    93,     0,    83,    84,     0,     0,     0,
       0,    82,    16,     0,    46,     0,    29,   102,   103,   105,
      44,   106,   101,    40,    52,     0,    63,    61,     0,    59,
      79,    67,     0,     0,     0,    97,    51,   100,    74,     0,
       0,    85,     0,    91,     0,     0,    19,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    13,     0,
      90,    80,     0,     0,    12,   104,     0,     0,     0,    77,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    64,
      62,    60,    68,    56,     0,    55,    94,    17,     0,    53,
       0,     0,    86,     0,     0,     0,     0,     0,    20,    57,
       0,     0,     0,     0,    14,     0,     0,     0,    21
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -160,  -160,  -160,   338,  -160,  -160,  -160,   366,  -160,  -160,
    -160,    -6,  -160,  -160,  -160,   -32,  -160,  -160,   -67,   215,
    -160,   -24,   -71,  -118,   238,   117,   -41,   248,   126,  -159,
    -160,  -160,  -108,   -63,  -160
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     2,     3,     4,   215,   233,   271,     5,    68,    65,
     149,    99,   223,   221,   220,    41,   224,    42,   100,   162,
     163,   144,   145,   176,   177,   146,   135,   136,   137,   169,
     131,   191,   152,    43,   113
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      40,   105,   115,   153,   112,   119,    90,    79,   204,    87,
     205,   205,   128,   205,   205,   205,     1,    88,   132,   212,
      28,   184,   171,    87,    44,    31,    32,    33,    34,    35,
      36,    88,    47,   180,    45,   175,   219,    48,   124,    87,
      76,   125,    51,    93,   175,    79,    49,    88,   140,   159,
     160,    37,   164,    31,    32,    33,    34,    35,    36,   211,
      79,    89,   117,   139,   116,   211,   172,   243,   206,   227,
      52,   230,   236,   254,   185,    89,   155,    38,    53,    37,
     165,   218,    39,   150,    76,   125,    46,   126,   210,   192,
     192,    89,   213,    79,   151,   173,    54,   216,    50,    31,
      32,    33,    34,    35,    36,    38,   158,   196,   192,   151,
      39,    79,    55,   151,   118,    31,    32,    33,    34,    35,
      36,   181,   151,    56,   202,    37,    31,    32,    33,    34,
      35,    36,   166,   209,    57,   181,   181,    58,   173,   214,
     181,    37,   158,   197,   217,    31,    32,    33,    34,    35,
      36,    38,    37,   161,   199,   192,    39,   154,   242,    59,
     244,   158,   201,    60,    61,    62,   151,    38,    63,    64,
      67,    37,    39,   157,   232,    85,    81,    66,    38,    80,
      86,    91,    94,    39,   170,    31,    32,    33,    34,    35,
      36,    95,   222,    96,    97,   248,   266,    38,    98,   101,
     102,   106,    39,   208,   107,    31,    32,    33,    34,    35,
      36,    37,   124,   260,   237,   238,   114,   240,   241,   120,
     127,   134,   167,   267,    82,    83,   246,   141,    84,   142,
     273,    37,   121,   122,   123,   133,   151,    38,   151,   138,
     168,   147,    39,   253,    31,    32,    33,    34,    35,    36,
      31,    32,    33,    34,    35,   187,   188,    38,    76,   125,
     151,   126,    39,   255,   148,   156,   158,   275,   161,   175,
      37,    31,    32,    33,    34,    35,   187,   188,    31,    32,
      33,    34,    35,   187,   188,    31,    32,    33,    34,    35,
     187,   188,   174,   178,   182,   186,    38,   194,   195,   180,
     198,    39,   269,   226,   203,   225,   228,   189,   190,   229,
     245,    31,    32,    33,    34,    35,    36,   231,    31,    32,
      33,    34,    35,   108,   234,   239,   247,   256,   189,   193,
     249,   250,   251,   252,   257,   189,   207,    37,   258,   259,
     262,    29,   189,   235,   109,    31,    32,    33,    34,    35,
     103,    31,    32,    33,    34,    35,   129,   263,   264,   268,
     270,    69,   272,    38,    70,   274,    71,   276,    92,    30,
     110,    69,   277,   278,    70,   111,    71,    72,   200,   265,
      73,     0,   261,    74,     0,     0,   183,    72,   179,     0,
      73,     0,     0,    74,    75,     0,     0,     0,     0,     0,
       0,     0,   104,     0,    75,     0,     0,     0,   130,     0,
       0,     0,    76,    77,     0,    78,     0,     0,     0,     0,
       0,     6,    76,   143,     7,    78,     8,     9,    10,    11,
      12,     0,    13,     0,     0,    14,     0,     0,    15,    16,
      17,    18,    19,    20,    21,    22,     0,     0,     0,     0,
       0,     0,     0,     0,    23,    24,     0,    25,    26,    27
};

static const yytype_int16 yycheck[] =
{
       6,    64,    69,   111,    67,    72,    47,    39,   167,     8,
       3,     3,    79,     3,     3,     3,    60,    16,    81,   178,
       0,     8,   130,     8,    61,     3,     4,     5,     6,     7,
       8,    16,     8,     8,     8,     8,   195,     8,    13,     8,
      59,    60,     8,    49,     8,    77,     8,    16,    89,   120,
     121,    29,   123,     3,     4,     5,     6,     7,     8,   177,
      92,    60,     8,    62,    70,   183,   133,   226,    61,    61,
       7,    61,    61,    61,    61,    60,   117,    55,    61,    29,
       8,   189,    60,    61,    59,    60,    60,    62,    61,   152,
     153,    60,    61,   125,   100,   136,    61,    61,    60,     3,
       4,     5,     6,     7,     8,    55,    60,    61,   171,   115,
      60,   143,    61,   119,    60,     3,     4,     5,     6,     7,
       8,   145,   128,     9,   165,    29,     3,     4,     5,     6,
       7,     8,    60,   174,     9,   159,   160,    61,   179,   180,
     164,    29,    60,    61,   185,     3,     4,     5,     6,     7,
       8,    55,    29,    60,    61,   218,    60,    61,   225,    61,
     227,    60,    61,    61,    60,     3,   172,    55,     3,     9,
       9,    29,    60,    61,   215,    60,     9,     8,    55,    61,
      46,     3,    46,    60,    61,     3,     4,     5,     6,     7,
       8,    60,   198,    61,    61,   236,   263,    55,    61,    61,
      61,    61,    60,    61,    61,     3,     4,     5,     6,     7,
       8,    29,    13,   254,   220,   221,    61,   223,   224,    60,
       8,     8,     8,   264,    57,    58,   232,    61,    61,    61,
     271,    29,    60,    60,    60,    60,   242,    55,   244,    60,
       3,    61,    60,    61,     3,     4,     5,     6,     7,     8,
       3,     4,     5,     6,     7,     8,     9,    55,    59,    60,
     266,    62,    60,    61,    60,    62,    60,   273,    60,     8,
      29,     3,     4,     5,     6,     7,     8,     9,     3,     4,
       5,     6,     7,     8,     9,     3,     4,     5,     6,     7,
       8,     9,    61,     8,    61,    61,    55,    61,     8,     8,
       8,    60,    61,     8,    62,    61,    61,    60,    61,    60,
       8,     3,     4,     5,     6,     7,     8,    61,     3,     4,
       5,     6,     7,     8,    61,    61,    60,    60,    60,    61,
      61,    61,    61,    61,    61,    60,    61,    29,     8,    61,
      60,     3,    60,    61,    29,     3,     4,     5,     6,     7,
       8,     3,     4,     5,     6,     7,     8,    61,    61,    61,
      61,     8,    61,    55,    11,    61,    13,    61,    60,     3,
      55,     8,    61,    61,    11,    60,    13,    24,   163,   262,
      27,    -1,   256,    30,    -1,    -1,   148,    24,   140,    -1,
      27,    -1,    -1,    30,    41,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    60,    -1,    41,    -1,    -1,    -1,    60,    -1,
      -1,    -1,    59,    60,    -1,    62,    -1,    -1,    -1,    -1,
      -1,    14,    59,    60,    17,    62,    19,    20,    21,    22,
      23,    -1,    25,    -1,    -1,    28,    -1,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    47,    48,    -1,    50,    51,    52
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    60,    64,    65,    66,    70,    14,    17,    19,    20,
      21,    22,    23,    25,    28,    31,    32,    33,    34,    35,
      36,    37,    38,    47,    48,    50,    51,    52,     0,    66,
      70,     3,     4,     5,     6,     7,     8,    29,    55,    60,
      74,    78,    80,    96,    61,     8,    60,     8,     8,     8,
      60,     8,     7,    61,    61,    61,     9,     9,    61,    61,
      61,    60,     3,     3,     9,    72,     8,     9,    71,     8,
      11,    13,    24,    27,    30,    41,    59,    60,    62,    78,
      61,     9,    57,    58,    61,    60,    46,     8,    16,    60,
      89,     3,    60,    74,    46,    60,    61,    61,    61,    74,
      81,    61,    61,     8,    60,    96,    61,    61,     8,    29,
      55,    60,    96,    97,    61,    81,    74,     8,    60,    81,
      60,    60,    60,    60,    13,    60,    62,     8,    81,     8,
      60,    93,    96,    60,     8,    89,    90,    91,    60,    62,
      89,    61,    61,    60,    84,    85,    88,    61,    60,    73,
      61,    74,    95,    95,    61,    89,    62,    61,    60,    85,
      85,    60,    82,    83,    85,     8,    60,     8,     3,    92,
      61,    95,    81,    89,    61,     8,    86,    87,     8,    90,
       8,    84,    61,    87,     8,    61,    61,     8,     9,    60,
      61,    94,    96,    61,    61,     8,    61,    61,     8,    61,
      82,    61,    89,    62,    92,     3,    61,    61,    61,    89,
      61,    86,    92,    61,    89,    67,    61,    89,    95,    92,
      77,    76,    74,    75,    79,    61,     8,    61,    61,    60,
      61,    61,    89,    68,    61,    61,    61,    74,    74,    61,
      74,    74,    81,    92,    81,     8,    74,    60,    89,    61,
      61,    61,    61,    61,    61,    61,    60,    61,     8,    61,
      89,    91,    60,    61,    61,    88,    81,    89,    61,    61,
      61,    69,    61,    89,    61,    74,    61,    61,    61
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    63,    64,    64,    64,    64,    65,    65,    66,    66,
      66,    66,    66,    66,    66,    66,    67,    66,    66,    68,
      69,    66,    66,    66,    66,    66,    66,    66,    66,    66,
      66,    66,    66,    66,    66,    70,    71,    71,    71,    71,
      71,    72,    72,    72,    72,    73,    73,    74,    74,    74,
      74,    74,    74,    74,    74,    74,    74,    74,    74,    75,
      74,    76,    74,    77,    74,    74,    74,    79,    78,    78,
      80,    80,    80,    80,    80,    81,    81,    82,    83,    83,
      84,    85,    85,    86,    87,    87,    88,    88,    89,    89,
      89,    89,    90,    90,    91,    91,    92,    92,    93,    93,
      93,    94,    94,    94,    94,    95,    95,    96,    96,    96,
      96,    96,    97,    97
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     1,     1,     2,     1,     2,     4,     4,
       4,     5,     8,     8,    16,     5,     0,    10,     5,     0,
       0,    19,     4,     4,     4,     3,     3,     3,     3,     6,
       3,     4,     4,     3,     4,     3,     1,     2,     2,     2,
       4,     1,     2,     2,     4,     0,     2,     1,     1,     1,
       1,     5,     5,     9,     4,     8,     8,    12,     4,     0,
       8,     0,     8,     0,     8,     2,     1,     0,     8,     4,
       3,     2,     3,     3,     5,     1,     2,     4,     1,     2,
       4,     1,     2,     1,     1,     2,     0,     1,     1,     1,
       5,     4,     1,     2,     0,     1,     1,     2,     1,     1,
       3,     1,     1,     1,     3,     0,     2,     1,     1,     1,
       1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* file: %empty  */
#line 161 "src/parsers/smtlib2/smtsyn.y"
                              { }
#line 1425 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 3: /* file: exit_command  */
#line 162 "src/parsers/smtlib2/smtsyn.y"
                              { /* skip */ }
#line 1431 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 4: /* file: script  */
#line 163 "src/parsers/smtlib2/smtsyn.y"
                              { /* skip */ }
#line 1437 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 5: /* file: script exit_command  */
#line 164 "src/parsers/smtlib2/smtsyn.y"
                              { /* skip */ }
#line 1443 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 6: /* script: command  */
#line 167 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_command(); }
#line 1449 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 7: /* script: script command  */
#line 168 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_command(); }
#line 1455 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 8: /* command: '(' "set-logic" SYMBOL ')'  */
#line 171 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_set_logic((yyvsp[-1].string)); }
#line 1461 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 9: /* command: '(' "set-info" info ')'  */
#line 172 "src/parsers/smtlib2/smtsyn.y"
                              { /* PF actual work in subrule */ }
#line 1467 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 10: /* command: '(' "set-option" option ')'  */
#line 173 "src/parsers/smtlib2/smtsyn.y"
                              { /* PF actual work in subrule */ }
#line 1473 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 11: /* command: '(' "declare-sort" SYMBOL NUMERAL ')'  */
#line 175 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_declare_sort((yyvsp[-2].string), (yyvsp[-1].string)); }
#line 1479 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 12: /* command: '(' "define-sort" SYMBOL '(' symbol_list_empty ')' sort ')'  */
#line 177 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_define_sort((yyvsp[-5].string), (yyvsp[-3].symbol_list), (yyvsp[-1].sort)); }
#line 1485 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 13: /* command: '(' "declare-fun" SYMBOL '(' sort_list_empty ')' sort ')'  */
#line 179 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_declare_fun((yyvsp[-5].string), (yyvsp[-3].sort_list), (yyvsp[-1].sort)); }
#line 1491 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 14: /* command: '(' "declare-fun" '(' "par" '(' sort_var_list ')' '(' SYMBOL '(' sort_list_empty ')' sort ')' ')' ')'  */
#line 183 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_declare_poly_fun((yyvsp[-7].string), (yyvsp[-10].sort_list), (yyvsp[-5].sort_list), (yyvsp[-3].sort)); }
#line 1497 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 15: /* command: '(' "declare-const" SYMBOL sort ')'  */
#line 185 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_declare_fun((yyvsp[-2].string), NULL, (yyvsp[-1].sort)); }
#line 1503 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 16: /* $@1: %empty  */
#line 187 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_declare_stack_var((yyvsp[-1].stack_var)); }
#line 1509 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 17: /* command: '(' "define-fun" SYMBOL '(' stack_var_empty ')' $@1 sort term ')'  */
#line 189 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_define_fun((yyvsp[-7].string), (yyvsp[-5].stack_var), (yyvsp[-2].sort), (yyvsp[-1].term));
                                smt2_undeclare_stack_var((yyvsp[-5].stack_var)); }
#line 1516 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 18: /* command: '(' "define-fun" SYMBOL term ')'  */
#line 192 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_define_fun_short((yyvsp[-2].string), (yyvsp[-1].term)); }
#line 1522 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 19: /* $@2: %empty  */
#line 195 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_declare_sort_var_list((yyvsp[-1].sort_list)); }
#line 1528 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 20: /* $@3: %empty  */
#line 197 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_declare_stack_var((yyvsp[-1].stack_var)); }
#line 1534 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 21: /* command: '(' "define-fun" '(' "par" '(' sort_var_list ')' $@2 '(' SYMBOL '(' stack_var_empty ')' $@3 sort term ')' ')' ')'  */
#line 199 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_define_poly_fun((yyvsp[-9].string), /*$6,*/ (yyvsp[-7].stack_var),
                                                     /*$15,*/ (yyvsp[-3].term));
                                smt2_undeclare_stack_var((yyvsp[-7].stack_var));
                                smt2_undeclare_sort_var_list((yyvsp[-13].sort_list)); }
#line 1543 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 22: /* command: '(' "push" NUMERAL ')'  */
#line 203 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_push((yyvsp[-1].string)); }
#line 1549 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 23: /* command: '(' "pop" NUMERAL ')'  */
#line 204 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_pop((yyvsp[-1].string)); }
#line 1555 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 24: /* command: '(' "assert" term ')'  */
#line 205 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_assert((yyvsp[-1].term)); }
#line 1561 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 25: /* command: '(' "check-sat" ')'  */
#line 206 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_check_sat(); }
#line 1567 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 26: /* command: '(' "get-assertions" ')'  */
#line 207 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_get_assertions(); }
#line 1573 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 27: /* command: '(' "get-proof" ')'  */
#line 208 "src/parsers/smtlib2/smtsyn.y"
                              {
  smt2_get_proof();
  }
#line 1581 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 28: /* command: '(' "get-unsat-core" ')'  */
#line 211 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_get_unsat_core(); }
#line 1587 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 29: /* command: '(' "get-value" '(' term_list ')' ')'  */
#line 214 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_get_value((yyvsp[-2].term_list)); }
#line 1593 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 30: /* command: '(' "get-assignment" ')'  */
#line 215 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_get_assignment(); }
#line 1599 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 31: /* command: '(' "get-info" KEYWORD ')'  */
#line 216 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_get_info((yyvsp[-1].string)); }
#line 1605 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 32: /* command: '(' "get-option" KEYWORD ')'  */
#line 217 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_get_option((yyvsp[-1].string)); }
#line 1611 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 33: /* command: '(' "get-model" ')'  */
#line 218 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_get_model(); }
#line 1617 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 34: /* command: '(' "echo" STRING ')'  */
#line 219 "src/parsers/smtlib2/smtsyn.y"
                        { smt2_echo((yyvsp[-1].string)); }
#line 1623 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 35: /* exit_command: '(' "exit" ')'  */
#line 222 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_exit(); YYACCEPT; }
#line 1629 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 36: /* option: KEYWORD  */
#line 236 "src/parsers/smtlib2/smtsyn.y"
                                 { smt2_set_option((yyvsp[0].string)); }
#line 1635 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 37: /* option: KEYWORD spec_const  */
#line 237 "src/parsers/smtlib2/smtsyn.y"
                                 { smt2_set_option_num((yyvsp[-1].string), (yyvsp[0].string)); }
#line 1641 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 38: /* option: KEYWORD SYMBOL  */
#line 238 "src/parsers/smtlib2/smtsyn.y"
                                 { smt2_set_option_str((yyvsp[-1].string), (yyvsp[0].string)); }
#line 1647 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 39: /* option: KEYWORD b_value  */
#line 239 "src/parsers/smtlib2/smtsyn.y"
                                 { smt2_set_option_bool((yyvsp[-1].string), (yyvsp[0].boolean)); }
#line 1653 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 40: /* option: KEYWORD '(' s_expr_list ')'  */
#line 240 "src/parsers/smtlib2/smtsyn.y"
                                 { /* PF refine if needed */ }
#line 1659 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 41: /* info: KEYWORD  */
#line 259 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_set_info((yyvsp[0].string)); }
#line 1665 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 42: /* info: KEYWORD spec_const  */
#line 260 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_set_info_str((yyvsp[-1].string), (yyvsp[0].string)); }
#line 1671 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 43: /* info: KEYWORD SYMBOL  */
#line 261 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_set_info_str((yyvsp[-1].string), (yyvsp[0].string)); }
#line 1677 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 44: /* info: KEYWORD '(' s_expr_list ')'  */
#line 262 "src/parsers/smtlib2/smtsyn.y"
                              { /* PF refine if needed */ }
#line 1683 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 45: /* symbol_list_empty: %empty  */
#line 265 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.symbol_list) = smt2_symbol_list_new(); }
#line 1689 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 46: /* symbol_list_empty: symbol_list_empty SYMBOL  */
#line 266 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.symbol_list) = smt2_symbol_list_add((yyvsp[-1].symbol_list), (yyvsp[0].string)); }
#line 1695 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 47: /* term: spec_const  */
#line 277 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.term) = smt2_term_const((yyvsp[0].string)); }
#line 1701 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 48: /* term: "true"  */
#line 278 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.term) = smt2_term(strmake("true")); }
#line 1707 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 49: /* term: "false"  */
#line 279 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.term) = smt2_term(strmake("false")); }
#line 1713 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 50: /* term: SYMBOL  */
#line 280 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.term) = smt2_term((yyvsp[0].string)); }
#line 1719 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 51: /* term: '(' '_' SYMBOL numeral_list ')'  */
#line 282 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.term) = smt2_iterm((yyvsp[-2].string), (yyvsp[-1].numeral_list)); }
#line 1725 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 52: /* term: '(' "as" SYMBOL sort ')'  */
#line 283 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.term) = smt2_term_s((yyvsp[-2].string), (yyvsp[-1].sort)); }
#line 1731 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 53: /* term: '(' "as" '(' '_' SYMBOL numeral_list ')' sort ')'  */
#line 285 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.term) = smt2_iterm_s((yyvsp[-4].string), (yyvsp[-3].numeral_list), (yyvsp[-1].sort)); }
#line 1737 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 54: /* term: '(' SYMBOL term_list ')'  */
#line 286 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.term) = smt2_term_app((yyvsp[-2].string), (yyvsp[-1].term_list)); }
#line 1743 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 55: /* term: '(' '(' '_' SYMBOL numeral_list ')' term_list ')'  */
#line 288 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.term) = smt2_iterm_app((yyvsp[-4].string), (yyvsp[-3].numeral_list), (yyvsp[-1].term_list)); }
#line 1749 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 56: /* term: '(' '(' "as" SYMBOL sort ')' term_list ')'  */
#line 290 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.term) = smt2_term_app_s((yyvsp[-4].string), (yyvsp[-1].term_list), (yyvsp[-3].sort)); }
#line 1755 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 57: /* term: '(' '(' "as" '(' '_' SYMBOL numeral_list ')' sort ')' term_list ')'  */
#line 292 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.term) = smt2_iterm_app_s((yyvsp[-6].string), (yyvsp[-5].numeral_list), (yyvsp[-1].term_list), (yyvsp[-3].sort)); }
#line 1761 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 58: /* term: '(' "distinct" term_list ')'  */
#line 294 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.term) = smt2_term_app("distinct", (yyvsp[-1].term_list)); }
#line 1767 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 59: /* $@4: %empty  */
#line 295 "src/parsers/smtlib2/smtsyn.y"
                              { smt2_declare_bind_list((yyvsp[-1].bind_list)); }
#line 1773 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 60: /* term: '(' "let" '(' bind_list ')' $@4 term ')'  */
#line 296 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.term) = smt2_let((yyvsp[-4].bind_list), (yyvsp[-1].term));
                                smt2_undeclare_bind_list((yyvsp[-4].bind_list)); }
#line 1780 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 61: /* $@5: %empty  */
#line 298 "src/parsers/smtlib2/smtsyn.y"
                                 { smt2_declare_stack_var((yyvsp[-1].stack_var)); }
#line 1786 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 62: /* term: '(' "forall" '(' stack_var ')' $@5 term ')'  */
#line 299 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.term) = smt2_term_forall((yyvsp[-4].stack_var), (yyvsp[-1].term));
                                smt2_undeclare_stack_var((yyvsp[-4].stack_var)); }
#line 1793 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 63: /* $@6: %empty  */
#line 301 "src/parsers/smtlib2/smtsyn.y"
                                 { smt2_declare_stack_var((yyvsp[-1].stack_var)); }
#line 1799 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 64: /* term: '(' "exists" '(' stack_var ')' $@6 term ')'  */
#line 302 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.term) = smt2_term_exists((yyvsp[-4].stack_var), (yyvsp[-1].term));
                                smt2_undeclare_stack_var((yyvsp[-4].stack_var)); }
#line 1806 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 65: /* term: term_attr ')'  */
#line 305 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.term) = (yyvsp[-1].term); }
#line 1812 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 66: /* term: lambda  */
#line 307 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.term) = (yyvsp[0].term); }
#line 1818 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 67: /* $@7: %empty  */
#line 311 "src/parsers/smtlib2/smtsyn.y"
                                 { smt2_declare_stack_var((yyvsp[-1].stack_var)); }
#line 1824 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 68: /* lambda: '(' "@lambda" '(' stack_var ')' $@7 term ')'  */
#line 312 "src/parsers/smtlib2/smtsyn.y"
                               { (yyval.term) = smt2_term_lambda((yyvsp[-4].stack_var), (yyvsp[-1].term));
                                 smt2_undeclare_stack_var((yyvsp[-4].stack_var)); }
#line 1831 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 69: /* lambda: '(' lambda term_list ')'  */
#line 314 "src/parsers/smtlib2/smtsyn.y"
                               { (yyval.term) = smt2_lambda_app((yyvsp[-2].term), (yyvsp[-1].term_list)); }
#line 1837 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 70: /* term_attr: '(' "!" term  */
#line 317 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.term) = (yyvsp[0].term); }
#line 1843 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 71: /* term_attr: term_attr KEYWORD  */
#line 318 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.term) = smt2_term_attr((yyvsp[-1].term), (yyvsp[0].string)); }
#line 1849 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 72: /* term_attr: term_attr KEYWORD attr_value  */
#line 320 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.term) = smt2_term_attr((yyvsp[-2].term), (yyvsp[-1].string)); }
#line 1855 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 73: /* term_attr: term_attr ":named" SYMBOL  */
#line 322 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.term) = smt2_term_attr_named((yyvsp[-2].term), (yyvsp[0].string)); }
#line 1861 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 74: /* term_attr: term_attr ":pattern" '(' term_list ')'  */
#line 324 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.term) = smt2_term_attr_pattern((yyvsp[-4].term), (yyvsp[-1].term_list)); }
#line 1867 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 75: /* term_list: term  */
#line 327 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.term_list) = smt2_term_list_one((yyvsp[0].term)); }
#line 1873 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 76: /* term_list: term_list term  */
#line 328 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.term_list) = smt2_term_list_add((yyvsp[-1].term_list), (yyvsp[0].term)); }
#line 1879 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 77: /* bind: '(' SYMBOL term ')'  */
#line 331 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.bind) = smt2_bind((yyvsp[-2].string), (yyvsp[-1].term)); }
#line 1885 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 78: /* bind_list: bind  */
#line 334 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.bind_list) = smt2_bind_list_one((yyvsp[0].bind)); }
#line 1891 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 79: /* bind_list: bind_list bind  */
#line 335 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.bind_list) = smt2_bind_list_add((yyvsp[-1].bind_list), (yyvsp[0].bind)); }
#line 1897 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 80: /* var: '(' SYMBOL sort ')'  */
#line 338 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.var) = smt2_var((yyvsp[-2].string), (yyvsp[-1].sort)); }
#line 1903 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 81: /* stack_var: var  */
#line 341 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.stack_var) = smt2_stack_var_one((yyvsp[0].var)); }
#line 1909 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 82: /* stack_var: stack_var var  */
#line 342 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.stack_var) = smt2_stack_var_add((yyvsp[-1].stack_var), (yyvsp[0].var)); }
#line 1915 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 83: /* sort_var: SYMBOL  */
#line 346 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.sort) = smt2_sort_var((yyvsp[0].string)); }
#line 1921 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 84: /* sort_var_list: sort_var  */
#line 349 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.sort_list) = smt2_sort_var_list_one((yyvsp[0].sort)); }
#line 1927 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 85: /* sort_var_list: sort_var_list sort_var  */
#line 350 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.sort_list) = smt2_sort_var_list_add((yyvsp[-1].sort_list), (yyvsp[0].sort)); }
#line 1933 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 86: /* stack_var_empty: %empty  */
#line 353 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.stack_var) = smt2_stack_var_new(); }
#line 1939 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 87: /* stack_var_empty: stack_var  */
#line 354 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.stack_var) = (yyvsp[0].stack_var); }
#line 1945 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 88: /* sort: "Bool"  */
#line 357 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.sort) = smt2_sort_lookup(strmake("Bool")); }
#line 1951 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 89: /* sort: SYMBOL  */
#line 358 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.sort) = smt2_sort_lookup((yyvsp[0].string)); }
#line 1957 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 90: /* sort: '(' '_' SYMBOL numeral_list ')'  */
#line 360 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.sort) = smt2_sort_lookup_index((yyvsp[-2].string), (yyvsp[-1].numeral_list)); }
#line 1963 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 91: /* sort: '(' sort sort_list ')'  */
#line 362 "src/parsers/smtlib2/smtsyn.y"
                           {
  if (smt2_sort_parametric((yyvsp[-2].sort)))
    (yyval.sort) = smt2_sort_apply((yyvsp[-2].sort), (yyvsp[-1].sort_list));
  else
    (yyval.sort) = smt2_sort_functional(list_cons(DAG_ptr_of_sort((yyvsp[-2].sort)), (yyvsp[-1].sort_list)));
  }
#line 1974 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 92: /* sort_list: sort  */
#line 374 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.sort_list) = smt2_sort_list_one((yyvsp[0].sort)); }
#line 1980 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 93: /* sort_list: sort_list sort  */
#line 375 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.sort_list) = smt2_sort_list_add((yyvsp[-1].sort_list), (yyvsp[0].sort)); }
#line 1986 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 94: /* sort_list_empty: %empty  */
#line 378 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.sort_list) = smt2_sort_list_new(); }
#line 1992 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 95: /* sort_list_empty: sort_list  */
#line 379 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.sort_list) = (yyvsp[0].sort_list); }
#line 1998 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 96: /* numeral_list: NUMERAL  */
#line 382 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.numeral_list) = smt2_numeral_list_one((yyvsp[0].string)); }
#line 2004 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 97: /* numeral_list: numeral_list NUMERAL  */
#line 383 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.numeral_list) = smt2_numeral_list_add((yyvsp[-1].numeral_list), (yyvsp[0].string)); }
#line 2010 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 98: /* attr_value: spec_const  */
#line 395 "src/parsers/smtlib2/smtsyn.y"
                              { /* PF TODO abstract */ }
#line 2016 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 99: /* attr_value: SYMBOL  */
#line 396 "src/parsers/smtlib2/smtsyn.y"
                              { /* PF TODO abstract */ }
#line 2022 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 100: /* attr_value: '(' s_expr_list ')'  */
#line 397 "src/parsers/smtlib2/smtsyn.y"
                              { /* PF TODO abstract */ }
#line 2028 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 101: /* s_expr: spec_const  */
#line 400 "src/parsers/smtlib2/smtsyn.y"
                              { /* PF TODO abstract */ }
#line 2034 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 102: /* s_expr: SYMBOL  */
#line 401 "src/parsers/smtlib2/smtsyn.y"
                              { /* PF TODO abstract */ }
#line 2040 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 103: /* s_expr: KEYWORD  */
#line 402 "src/parsers/smtlib2/smtsyn.y"
                              { /* PF TODO abstract */ }
#line 2046 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 104: /* s_expr: '(' s_expr_list ')'  */
#line 403 "src/parsers/smtlib2/smtsyn.y"
                              { /* PF TODO abstract */ }
#line 2052 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 105: /* s_expr_list: %empty  */
#line 406 "src/parsers/smtlib2/smtsyn.y"
                              { /* PF TODO abstract */ }
#line 2058 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 106: /* s_expr_list: s_expr_list s_expr  */
#line 407 "src/parsers/smtlib2/smtsyn.y"
                              { /* PF TODO abstract */ }
#line 2064 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 107: /* spec_const: NUMERAL  */
#line 410 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.string) = (yyvsp[0].string); }
#line 2070 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 108: /* spec_const: DECIMAL  */
#line 411 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.string) = (yyvsp[0].string); }
#line 2076 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 109: /* spec_const: HEXADECIMAL  */
#line 412 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.string) = (yyvsp[0].string); }
#line 2082 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 110: /* spec_const: BINARY  */
#line 413 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.string) = (yyvsp[0].string); }
#line 2088 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 111: /* spec_const: STRING  */
#line 414 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.string) = (yyvsp[0].string); }
#line 2094 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 112: /* b_value: "true"  */
#line 417 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.boolean) = true; }
#line 2100 "src/parsers/smtlib2/smtsyn.c"
    break;

  case 113: /* b_value: "false"  */
#line 418 "src/parsers/smtlib2/smtsyn.y"
                              { (yyval.boolean) = false; }
#line 2106 "src/parsers/smtlib2/smtsyn.c"
    break;


#line 2110 "src/parsers/smtlib2/smtsyn.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 421 "src/parsers/smtlib2/smtsyn.y"


extern void initlex(char *arg);

extern FILE *yyin;

void
parse_smtlib2(FILE * input, bool option_disable_print_success)
{
#ifdef DEBUG_PARSER
  yydebug = 1;
#endif
  yylineno = 1;
  yyin = input;
  if (!yyin)
    veriT_error("parse_smtlib2: no input file");
  smt2_init(option_disable_print_success);
  yyparse();
  smt2_done();
  yylex_destroy();
}
